/*
 * Copyright 2007 Project RELIC
 *
 * This file is part of RELIC. RELIC is legal property of its developers,
 * whose names are not listed here. Please refer to the COPYRIGHT file.
 *
 * RELIC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * RELIC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with RELIC. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * @file
 *
 * Implementation of the low-level binary field bit shifting functions.
 *
 * @version $Id$
 * @ingroup fb
 */

#include "relic_fb_low.h"

.global fb_rdcn_low_asm

.arm
.align


/*============================================================================*/
/* Public definitions                                                         */
/*============================================================================*/


#if FB_POLYN == 283
#include "relic_fb_rdc_low_283.s"
fb_rdcn_low_asm:
    vldm r1, {d0-d8}
    rdc283m q0, d0, d1, q1, d2, d3, d4, q0, d0, d1, q1, d2, d3, q2, d4, d5, q3, d6, d7, d8
    vstm r0, {d0-d4}
    bx lr

#endif
