/*
 * Copyright 2007 Project RELIC
 *
 * This file is part of RELIC. RELIC is legal property of its developers,
 * whose names are not listed here. Please refer to the COPYRIGHT file.
 *
 * RELIC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * RELIC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with RELIC. If not, see <http://www.gnu.org/licenses/>.
 */

.macro rdc283m_old
    //57 inst
    vshl.I64 d9, d8, #(32+5)
    vshl.I64 d10, d8, #(32+10)
    veor d3, d3, d9
    vshl.I64 d9, d8, #(32+12)
    veor d3, d3, d10
    vshl.I64 d10, d8, #(32+17)
    veor d3, d3, d9

    vshr.U64 d9, d8, #15
    veor d3, d3, d10
    vshr.U64 d10, d8, #20
    veor d4, d4, d9
    vshr.U64 d9, d8, #22
    veor d4, d4, d10
    vshr.U64 d20, d8, #27
    veor d4, d4, d9

    vshl.I64 q5, q3, #(32+5)
    veor d4, d4, d20
    vshl.I64 q6, q3, #(32+10)
    veor d1, d1, d10
    veor d2, d2, d11
    vshl.I64 q5, q3, #(32+12)
    veor d1, d1, d12
    veor d2, d2, d13
    vshl.I64 q6, q3, #(32+17)
    veor d1, d1, d10
    veor d2, d2, d11
    veor d1, d1, d12
    veor d2, d2, d13

    vshr.U64 q5, q3, #15
    vshr.U64 q6, q3, #20
    veor q1, q1, q5
    vshr.U64 q5, q3, #22
    veor q1, q1, q6
    vshr.U64 q6, q3, #27
    veor q1, q1, q5

    //copy d4-d5 in d6-d7
    vmov q3, q2
    veor q1, q1, q6
    //clear lower 27 bits of the copy
    //clear higher 37 bits of the original
    vshr.U64 d6, d6, #27
    vshl.I64 d4, d4, #37

    vshl.I64 d11, d7, #(32+5)
    vshl.I64 d13, d7, #(32+10)
        vshl.I64 d6, d6, #27
        vshr.U64 d4, d4, #37
    veor d0, d0, d11
    vshl.I64 d11, d7, #(32+12)
    veor d0, d0, d13
    vshl.I64 d13, d7, #(32+17)
    veor d0, d0, d11

    vshr.U64 q5, q3, #15
    veor d0, d0, d13
    vshr.U64 q6, q3, #20
    veor q0, q0, q5
    vshr.U64 q5, q3, #22
    veor q0, q0, q6
    vshr.U64 q6, q3, #27
    veor q0, q0, q5
    veor q0, q0, q6
.endm

.macro rdc283m r0q, r0l, r0h, r1q, r1l, r1h, r2d, a0q, a0l, a0h, a1q, a1l, a1h, a2q, a2l, a2h, a3q, a3l, a3h, a4d
    //input: d0--d8
    //output: d0--d4
    //52 inst

    //shifts upper part >> 27 (aligns it)
    //[d16:d20] = [a4:a8] >> 27
    vshr.U64 d20, \a4d, #27
    vshr.U64 q9, \a3q, #27
    vshr.U64 q8, \a2q, #27
    //[d26:d29] = [a4:a8] << 37
    vsli.64 d19, \a4d, #37
    vsli.64 d18, \a3h, #37
    vsli.64 d17, \a3l, #37
    vsli.64 d16, \a2h, #37
    @vshl.I64 d29, \a4d, #37
    @vshl.I64 d28, \a3h, #37
    @vshl.I64 d27, \a3l, #37
    @vshl.I64 d26, \a2h, #37
    //[d16:d20] = [d16:d20] ^ [d26:d29]
    @veor q9, q14
    @veor q8, q13

    //multiplies by (z^7 + 1)

    //[d22:d26] = [d16:d20] << 7
    vshl.I64 d26, d20, #7
    vshl.I64 q12, q9, #7
    vshl.I64 q11, q8, #7
    //[x:d28:d31] = [d16:d19] >> 57
    @vshr.U64 q15, q9, #57
    @vshr.U64 q14, q8, #57
    vsri.64 d26, d19, #57
    vsri.64 d25, d18, #57
    vsri.64 d24, d17, #57
    vsri.64 d23, d16, #57
    //[d16:d20] ^= [d22:d26]
        //[d16:d20] ^= [x:d28:d31]
    veor d20, d26
    veor q9, q12
        @veor d20, d31
    veor q8, q11
        @veor d19, d30
        @veor d18, d29
        @veor d17, d28

    //multiplies by (z^5 + 1)
    //aligns leftover, reduces it

    //[d22:d26] = [d16:d20] << 5
    vshl.I64 d26, d20, #5
    vshl.I64 q12, q9, #5
    vshl.I64 q11, q8, #5
    //[x:d27:d30] = [d16:d20] >> 59
    @vshr.U64 d30, d19, #59
    @vshr.U64 d29, d18, #59
    @vshr.U64 d28, d17, #59
    @vshr.U64 d27, d16, #59
    vsri.64  d26, d19, #59
    vsri.64  d25, d18, #59
        //[d16:d20] ^= [d22:d26]
        veor d20, d26
    vsri.64  d24, d17, #59
    vsri.64  d23, d16, #59
            //[d16:d20] ^= [x:d27:d30]
            @veor d20, d30
                //a3l = d20 >> 27
                vshr.U64 \a3l, d20, #27
        veor q9, q12
            @veor q9, q14
            @veor d17, d27
                //a3h = a3l << 7
                vshl.I64 \a3h, \a3l, #7
        veor q8, q11
                //a3l ^= a3h
                veor \a3l, \a3h

    //[a0:a4] ^= [d16:d20]
    veor d4, d20
                //a3h = a3l << 5
                vshl.I64 \a3h, \a3l, #5
    veor \r1q, q9
                //a3l ^= a3h
                veor \a3l, \a3h
    veor \r0q, q8
        //clear high bits of last word
        vshl.I64 d4, d4, #37
    veor \r0l, \a3l
        vshr.U64 \r2d, d4, #37
.endm

.macro rdc251m r0q, r0l, r0h, r1q, r1l, r1h, a0q, a0l, a0h, a1q, a1l, a1h, a2q, a2l, a2h, a3q, a3l, a3h
    //input: d0--d7
    //output: d0--d3

    //shifts upper part << 5 (aligns it)
    //[d16:d19] = [a4:a7] << 5
    vshl.U64 q9, \a3q, #27
    vshl.U64 q8, \a2q, #27
    //[d16:d19] ^= [a3:a7] >> 61
    vsli.64 d19, \a3l, #61
    vsli.64 d18, \a2h, #61
    vsli.64 d17, \a2l, #61
    vsli.64 d16, \a1h, #61

    //todo...

    //multiplies by (z^7 + 1)

    //[d22:d26] = [d16:d20] << 7
    vshl.I64 d26, d20, #7
    vshl.I64 q12, q9, #7
    vshl.I64 q11, q8, #7
    //[x:d28:d31] = [d16:d19] >> 57
    @vshr.U64 q15, q9, #57
    @vshr.U64 q14, q8, #57
    vsri.64 d26, d19, #57
    vsri.64 d25, d18, #57
    vsri.64 d24, d17, #57
    vsri.64 d23, d16, #57
    //[d16:d20] ^= [d22:d26]
        //[d16:d20] ^= [x:d28:d31]
    veor d20, d26
    veor q9, q12
        @veor d20, d31
    veor q8, q11
        @veor d19, d30
        @veor d18, d29
        @veor d17, d28

    //multiplies by (z^5 + 1)
    //aligns leftover, reduces it

    //[d22:d26] = [d16:d20] << 5
    vshl.I64 d26, d20, #5
    vshl.I64 q12, q9, #5
    vshl.I64 q11, q8, #5
    //[x:d27:d30] = [d16:d20] >> 59
    @vshr.U64 d30, d19, #59
    @vshr.U64 d29, d18, #59
    @vshr.U64 d28, d17, #59
    @vshr.U64 d27, d16, #59
    vsri.64  d26, d19, #59
    vsri.64  d25, d18, #59
        //[d16:d20] ^= [d22:d26]
        veor d20, d26
    vsri.64  d24, d17, #59
    vsri.64  d23, d16, #59
            //[d16:d20] ^= [x:d27:d30]
            @veor d20, d30
                //a3l = d20 >> 27
                vshr.U64 \a3l, d20, #27
        veor q9, q12
            @veor q9, q14
            @veor d17, d27
                //a3h = a3l << 7
                vshl.I64 \a3h, \a3l, #7
        veor q8, q11
                //a3l ^= a3h
                veor \a3l, \a3h

    //[a0:a4] ^= [d16:d20]
    veor d4, d20
                //a3h = a3l << 5
                vshl.I64 \a3h, \a3l, #5
    veor \r1q, q9
                //a3l ^= a3h
                veor \a3l, \a3h
    veor \r0q, q8
        //clear high bits of last word
        vshl.I64 d4, d4, #37
    veor \r0l, \a3l
        vshr.U64 \r2d, d4, #37
.endm

