#include "relic_fb_low.h"
#include "relic_fb_rdc_low_283.s"

.arm
.align
.globl fb_sqrn_low_asm
.globl fb_sqrm_low_asm
.globl fb_itr_low_asm

.macro sqr283m
    vmull.p8 q15, d4, d4
    vmull.p8 q3, d3, d3
    vmull.p8 q2, d2, d2
    vmull.p8 q1, d1, d1
    vmull.p8 q0, d0, d0
.endm

.macro sqr163fullm
    vmull.p8    q12, d2, d2
    vmull.p8    q11, d1, d1
    vmull.p8    q10, d0, d0
    vshl.s64    q14, q12, #29
    vmov.i8 d30, #201
    vsri.u64    d29, d24, #35
    vsri.u64    d28, d23, #35
    vmull.p8    q13, d29, d30
    vmull.p8    q14, d28, d30
    vshl.s64    d23, d23, #29
    vuzp.8  d26, d27
    veor    d22, d22, d26
    vshl.s64    d27, d27, #8
    vuzp.8  d28, d29
    veor    d22, d22, d27
    veor    d21, d21, d28
    vshr.u64    d0, d29, #56
    vshr.u64    d1, d22, #35
    vshl.s64    d29, d29, #8
    veor    q11, q11, q0
    vmull.p8    q13, d23, d30
    veor    d21, d21, d29
    vshl.s64    d22, d22, #29
    vuzp.8  d26, d27
    veor    d20, d20, d26
    vshl.s64    d26, d27, #8
    vshr.u64    d27, d27, #56
    vshr.u64    d2, d22, #29
    veor    q0, q10, q13
.endm

.macro sqr251fullm
    //[d23:d16] = [a7:a0]
    vmull.p8    q11, d3, d3
    vmull.p8    q10, d2, d2
    vmull.p8    q9, d1, d1
    vmull.p8    q8, d0, d0
    //shifts upper part << 5 (aligns it)
    //[d23:d22:d21:d20:d19]
    //[d27:d26] = [d23:d22:d21] << 5
    vshl.s64    q13, q11, #5
    vsri.64    d27, d22, #59
    vsri.64    d26, d21, #59
    //d28 = r(z)
    vmov.i8 d28, #149
    //[d25:d24] = d27 * r(z)
    vmull.p8    q12, d27, d28
    //[d27:d26] = d26 * r(z)
    vmull.p8    q13, d26, d28
    //[d25:d24] = d27 * r(z) (H:L)
    vuzp.8  d24, d25
    //[d27:d26] = d26 * r(z) (H:L)
    vuzp.8  d26, d27
    //xor low parts
    veor    d19, d19, d24
    veor    d18, d18, d26
    //shift high parts << 8
    vshl.s64    d24, d25, #8
    vshl.s64    d26, d27, #8
    //xor d27 * r(z) H
    veor    d19, d19, d24
    vshr.u64    d25, d25, #56
    vshr.u64    d27, d27, #56
    veor    d20, d20, d25
    veor    q9, q9, q13
    vshl.s64    q13, q10, #5
    vsri.64    d27, d20, #59
    vsri.64    d26, d19, #59
    vmull.p8    q12, d27, d28
    vmull.p8    q13, d26, d28
    vshl.s64    d19, d19, #5
    vuzp.8  d24, d25
    vuzp.8  d26, d27
    veor    d17, d17, d24
    veor    d16, d16, d26
    vshl.s64    d24, d25, #8
    vshl.s64    d26, d27, #8
    veor    d17, d17, d24
    vshr.u64    d25, d25, #56
    vshr.u64    d27, d27, #56
    veor    q0, q8, q13
    veor    d2, d18, d25
    vshr.u64    d3, d19, #5
.endm

.macro sqr353fullm
    vmull.p8    q13, d5, d5
    vmull.p8    q12, d4, d4
    vmull.p8    q11, d3, d3
    vmull.p8    q10, d2, d2
    vmull.p8    q9, d1, d1
    vmull.p8    q8, d0, d0
    vshr.u64    d2, d26, #28
    vshr.u64    q0, q12, #28
    veor    d22, d22, d2
    vshl.s64    q1, q13, #36
    veor    q10, q10, q0
    vshl.s64    q0, q12, #36
    veor    d22, d22, d3
    veor    d21, d21, d2
    vshr.u64    d2, d26, #33
    veor    d20, d20, d1
    veor    d19, d19, d0
    vshr.u64    q0, q12, #33
    veor    d21, d21, d2
    vshl.s64    q1, q13, #31
    veor    d20, d20, d1
    veor    d19, d19, d0
    vshl.s64    q0, q12, #31
    veor    q2, q10, q1
    vshr.u64    q15, q11, #28
    veor    q9, q9, q0
    vshr.u64    d0, d5, #33
    veor    q1, q9, q15
    vshl.s64    q15, q11, #36
    veor    d16, d16, d0
    vshl.s64    d0, d0, #5
    veor    d2, d2, d31
    veor    d17, d17, d30
    vshr.u64    q15, q11, #33
    veor    d17, d17, d0
    vshl.s64    d5, d5, #31
    veor    d2, d2, d31
    veor    d17, d17, d30
    vshl.s64    q15, q11, #31
    vshr.u64    d5, d5, #31
    veor    q0, q8, q15
.endm

.macro sqr571fullm
    vmull.p8    q8, d0, d0
    vmull.p8    q9, d1, d1
    vmull.p8    q10, d2, d2
    vmull.p8    q11, d3, d3
    vmull.p8    q12, d4, d4
    vmull.p8    q13, d5, d5
    vmull.p8    q14, d6, d6
    vmull.p8    q15, d7, d7
    vmull.p8    q3, d8, d8
    vshl.s64    d1, d7, #5
    vshr.u64    d0, d6, #59
    vmov.i8 d7, #37
    veor    d1, d0, d1
    vmull.p8    q1, d1, d7
    vshl.s64    d0, d1, #10
    vshr.u64    d1, d1, #54
    veor    q12, q12, q0
    vuzp.8  d2, d3
    vshl.s64    d3, d3, #8
    vshl.s64    d5, d6, #5
    vshl.s64    d4, d31, #5
    vshr.u64    q3, q15, #59
    vmov.i8 d31, #37
    veor    d24, d24, d2
    veor    q3, q3, q2
    veor    d24, d24, d3
    vmull.p8    q0, d7, d31
    vmull.p8    q1, d6, d31
    vshl.s64    q2, q3, #10
    vshr.u64    q3, q3, #54
    veor    q11, q11, q2
    veor    d24, d24, d7
    veor    d23, d23, d6
    vuzp.8  d0, d1
    vuzp.8  d2, d3
    vshr.u64    d5, d1, #56
    vshr.u64    d4, d3, #56
    veor    d23, d23, d0
    veor    d22, d22, d2
    vshl.s64    d1, d1, #8
    vshl.s64    d0, d3, #8
    veor    d23, d23, d4
    vshl.s64    d3, d30, #5
    vshl.s64    d2, d29, #5
    vshr.u64    q3, q14, #59
    veor    d24, d24, d5
    veor    q3, q3, q1
    //d23
    veor    q11, q11, q0
    vmull.p8    q0, d7, d31
    vmull.p8    q1, d6, d31
    vshl.s64    q2, q3, #10
    vshr.u64    q3, q3, #54
    veor    q10, q10, q2
    veor    d22, d22, d7
    veor    d21, d21, d6
    vuzp.8  d0, d1
    vuzp.8  d2, d3
    vshr.u64    d5, d1, #56
    vshr.u64    d4, d3, #56
    veor    d21, d21, d0
    veor    d20, d20, d2
    vshl.s64    d1, d1, #8
    vshl.s64    d0, d3, #8
    veor    d21, d21, d4
    vshl.s64    d3, d28, #5
    vshl.s64    d2, d27, #5
    vshr.u64    q3, q13, #59
    //d22
    veor    d22, d22, d5
    veor    q3, q3, q1
    //d21
    veor    q10, q10, q0
    vmull.p8    q0, d7, d31
    vmull.p8    q1, d6, d31
    vshl.s64    q2, q3, #10
    vshr.u64    q3, q3, #54
    veor    q9, q9, q2
    veor    d20, d20, d7
    veor    d19, d19, d6
    vuzp.8  d0, d1
    vuzp.8  d2, d3
    vshr.u64    d5, d1, #56
    vshr.u64    d4, d3, #56
    veor    d19, d19, d0
    veor    d18, d18, d2
    vshl.s64    d1, d1, #8
    vshl.s64    d0, d3, #8
    veor    d19, d19, d4
    vshl.s64    d3, d26, #5
    vshl.s64    d2, d25, #5
    vshr.u64    q3, q12, #59
    //d20
    veor    d20, d20, d5
    veor    q3, q3, q1
    //d19
    veor    q9, q9, q0
    vmull.p8    q0, d7, d31
    vmull.p8    q1, d6, d31
    vshl.s64    q2, q3, #10
    vshr.u64    q3, q3, #54
    veor    q8, q8, q2
    veor    d18, d18, d7
    veor    d17, d17, d6
    vuzp.8  d0, d1
    vuzp.8  d2, d3
    vshr.u64    d5, d1, #56
    vshr.u64    d4, d3, #56
    veor    d17, d17, d0
    veor    d16, d16, d2
    vshl.s64    d1, d1, #8
    vshl.s64    d0, d3, #8
    veor    d17, d17, d4
    vshl.s64    d24, d24, #5
    //d18
    veor    d18, d18, d5
    //d16, d17
    veor    q8, q8, q0
    //d24
    vshr.u64    d24, d24, #5
.endm


fb_sqrm_low_asm:
#if FB_POLYN == 163
    vld1.64 {d0-d2}, [r1:64]
    sqr163fullm
    vst1.64 {d0-d2}, [r0:64]
    bx lr
#elif FB_POLYN == 251
    @vld1.64 {d0-d3}, [r1:64]
    vldm r1, {d0-d3}
    sqr251fullm
    @vst1.64 {d0-d3}, [r0:64]
    vstm r0, {d0-d3}
    bx lr
#elif FB_POLYN == 353
    vldm r1, {d0-d5}
    sqr353fullm
    vstm r0, {q0-q2}
    bx lr
#elif FB_POLYN == 571
    vldm r1, {d0-d8}
    sqr571fullm
    vstm r0, {d16-d24}
    bx lr
#elif FB_POLYN == 283
    vldm r1, {d0-d4}
    sqr283m
    rdc283m q0, d0, d1, q1, d2, d3, d4, q0, d0, d1, q1, d2, d3, q2, d4, d5, q3, d6, d7, d30
    vstm r0, {d0-d4}
    bx lr
#endif


fb_sqrn_low_asm:
    vldm r1!, {d0-d4}
    sqr283m
    vstm r0!, {d0-d7}
    vstm r0!, {d8}
    bx lr


fb_itr_low_asm:
#if FB_POLYN == 163
    vld1.64 {d0-d2}, [r1:64]
    back:
    sqr163fullm
    subs r2, #1
    bne back
    vst1.64 {d0-d2}, [r0:64]
    bx lr

#elif FB_POLYN == 251
    vld1.64 {d0-d3}, [r1:64]
    back:
    sqr251fullm
    subs r2, #1
    bne back
    vst1.64 {d0-d3}, [r0:64]
    bx lr

#elif FB_POLYN == 353
    vldm r1!, {d0-d5}
    back:
    sqr353fullm
    subs r2, #1
    bne back
    vstm r0!, {d0-d5}
    bx lr

#elif FB_POLYN == 571
    vldm r1!, {d0-d8}
    back:
    sqr571fullm
    vmov q0,q8
    vmov q1,q9
    vmov q2,q10
    vmov q3,q11
    vmov d8,d24
    subs r2, #1
    bne back
    vstm r0!, {d0-d8}
    bx lr

#elif FB_POLYN == 283
    vldm r1!, {d0-d4}
    back:
    sqr283m
    rdc283m q0, d0, d1, q1, d2, d3, d4, q0, d0, d1, q1, d2, d3, q2, d4, d5, q3, d6, d7, d30
    subs r2, #1
    bne back
    vstm r0!, {d0-d4}
    bx lr
#endif
