/*
 * RELIC is an Efficient LIbrary for Cryptography
 * Copyright (C) 2007-2012 RELIC Authors
 *
 * This file is part of RELIC. RELIC is legal property of its developers,
 * whose names are not listed here. Please refer to the COPYRIGHT file
 * for contact information.
 *
 * RELIC is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * RELIC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with RELIC. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * @file
 *
 * Implementation of the low-level trace function.
 *
 * @version $Id$
 * @ingroup fb
 */

#include "relic_fb.h"
#include "relic_fb_low.h"
#include "ecc_gf.h"

/*============================================================================*/
/* Public definitions                                                         */
/*============================================================================*/

dig_t fb_trcn_low(dig_t *a) {
#if FB_POLYN == 163
    return gf_b163_trace(a);
#elif FB_POLYN == 233
    return gf_b233_trace(a);
#elif FB_POLYN == 283
    return gf_b283_trace(a);
#elif FB_POLYN == 409
    return gf_b409_trace(a);
#elif FB_POLYN == 571
    return gf_b571_trace(a);
#elif FB_POLYN == 251
    return gf_r251_trace(a);
#elif FB_POLYN == 271
    return gf_s271_trace(a);
#elif FB_POLYN == 353
    return gf_s353_trace(a);
#endif
}
