#include "relic_fb_low.h"

.arm
.align
.globl fb_sel_asm
.globl eb_choose_asm
.globl asmdummy
.globl fb_addn_low_asm
.globl bn_ccopyn_low

asmdummy:
    bx lr

fb_addn_low_asm:
#if FB_POLYN == 163
    vld1.64 {d0-d2}, [r1:64]
    vld1.64 {d4-d6}, [r2:64]
    veor    q0, q0, q2
    veor    d2, d2, d6
    vst1.64 {d0-d2}, [r0:64]
    bx lr
#elif FB_POLYN == 251
    vld1.64 {d0-d3}, [r1:64]
    vld1.64 {d4-d7}, [r2:64]
    veor    q0, q0, q2
    veor    q1, q1, q3
    vst1.64 {d0-d3}, [r0:64]
    bx lr
#elif FB_POLYN == 283
    vldm r1, {d16-d20}
    vldm r2, {d22-d26}
    veor    q8, q8, q11
    veor    q9, q9, q12
    veor    d20, d20, d26
    vstm r0, {d16-d20}
    bx lr
#elif FB_POLYN == 353
    vldm r1, {d16-d21}
    vldm r2, {d22-d27}
    veor    q8, q8, q11
    veor    q9, q9, q12
    veor    q10, q10, q13
    vstm r0, {d16-d21}
    bx lr
#elif FB_POLYN == 571
    vldm r1, {d0-d8}
    vldm r2, {d16-d24}
    veor    q0, q0, q8
    veor    q1, q1, q9
    veor    q2, q2, q10
    veor    q3, q3, q11
    veor    d8, d8, d24
    vstm r0, {d0-d8}
    bx lr
#endif


.macro select3 selq, seld, r0q, r1d, a0q, a1d, b0q, b1d
    vbif \r0q, \a0q, \selq
    vbif \r1d, \a1d, \seld
.endm

.macro select4 selq, r0q, r1q, a0q, a1q, b0q, b1q
    vbif \r0q, \a0q, \selq
    vbif \r1q, \a1q, \selq
.endm

.macro select5 selq, seld, r0q, r1q, r2d, a0q, a1q, a2d, b0q, b1q, b2d
    vbif \r0q, \a0q, \selq
    vbif \r1q, \a1q, \selq
    vbif \r2d, \a2d, \seld
.endm

.macro select6 selq, seld, r0q, r1q, r2q, a0q, a1q, a2q, b0q, b1q, b2q
    vbif \r0q, \a0q, \selq
    vbif \r1q, \a1q, \selq
    vbif \r2q, \a2q, \selq
.endm

.macro select9 selq, seld, r0q, r1q, r2q, r3q, r4d, a0q, a1q, a2q, a3q, a4d, b0q, b1q, b2q, b3q, b4d
    vbif \r0q, \a0q, \selq
    vbif \r1q, \a1q, \selq
    vbif \r2q, \a2q, \selq
    vbif \r3q, \a3q, \selq
    vbif \r4d, \a4d, \seld
.endm

//void fb_sel(fb_t c, fb_t a, fb_t b, int bit) {
fb_sel_asm:
    vdup.32 q15, r3
    vldm r1, {d16-d20}
    vneg.S32 q15, q15
    vldm r2, {d22-d26}
    select5 q15, d30, q0, q1, d4, q8, q9, d20, q11, q12, d26
    vstm r0, {d0-d4}
    bx lr


//void eb_choose(eb_t r, eb_t *t, int w, signed char v) {
eb_choose_asm:
#if FB_POLYN == 163
    push {lr}

    //load t[0]->x
    vldm r1!, {d16-d18}
    //load t[0]->y
    vldm r1!, {d22-d24}
    //move to t[1]
    add r1, #(80-48)

    //ip = 1 (i)
    mov r12, #1
    //r2 = (1 << w)
    lsl r2, r12, r2
back:
    //while (ip < r2)
    cmp r12, r2
    bge end

    //load t[i]->x
    vldm r1!, {d0-d2}

    mov lr, #0xFF
    cmp r3, r12
    moveq lr, #0
    vdup.8 q15, lr

    select3 q15, d30, q8, d18, q0, d2, q8, d18

    //load t[i]->y
    vldm r1!, {d26-d28}

    //move to t[i+1]
    add r1, #(80-48)
    add r12, #1

    select3 q15, d30, q11, d24, q13, d28, q11, d24

    b back
end:
    vstm r0!, {d16-d18}
    vstm r0!, {d22-d24}

    vmov.i64 d0, #0xFF
    vmov.i64 d1, #0
    vshr.U64 d0, #7
    vmov.i64 d2, #0
    vmov.i64 d3, d0
    vstm r0!, {d0-d3}

    pop {pc}

#elif FB_POLYN == 251
    push {lr}

    //load t[0]->x
    vldm r1!, {d16-d19}
    //load t[0]->y
    vldm r1!, {d22-d25}
    //move to t[1]
    add r1, #(5*8)

    //ip = 1 (i)
    mov r12, #1
    //r2 = (1 << w)
    lsl r2, r12, r2
back:
    //while (ip < r2)
    cmp r12, r2
    bge end

    //load t[i]->x
    vldm r1!, {d0-d3}
    vmov d5, d30

    mov lr, #0xFF
    cmp r3, r12
    moveq lr, #0
    vdup.8 q15, lr

    select4 q15, q8, q9, q0, q1, q8, q9

    //load t[i]->y
    vldm r1!, {d0-d3}

    //move to t[i+1]
    add r1, #(5*8)
    add r12, #1

    select4 q15, q11, q12, q0, q1, q11, q12

    b back
end:
    vstm r0!, {d16-d19}
    vstm r0!, {d22-d25}

    vmov.i64 d0, #0xFF
    vmov.i64 d1, #0
    vshr.U64 d0, #7
    vmov.i64 q1, #0
    vmov.i64 d4, d0
    vstm r0!, {d0-d4}

    pop {pc}

#elif FB_POLYN == 283
    push {lr}

    //load t[0]->x
    vldm r1!, {d16-d20}
    //load t[0]->y
    vldm r1!, {d22-d26}
    //move to t[1]
    add r1, #(128-80)

    //ip = 1 (i)
    mov r12, #1
    //r2 = (1 << w)
    lsl r2, r12, r2
back:
    //while (ip < r2)
    cmp r12, r2
    bge end

    //load t[i]->x
    vldm r1!, {d0-d4}

    mov lr, #0xFF
    cmp r3, r12
    moveq lr, #0
    vdup.8 q15, lr

    select5 q15, d30, q8, q9, d20, q0, q1, d4, q8, q9, d20

    //load t[i]->y
    vldm r1!, {d0-d4}

    //move to t[i+1]
    add r1, #(128-80)
    add r12, #1

    select5 q15, d30, q11, q12, d26, q0, q1, d4, q11, q12, d26

    b back
end:
    vstm r0!, {d16-d20}
    vstm r0!, {d22-d26}

    vmov.i64 d0, #0xFF
    vmov.i64 d1, #0
    vshr.U64 d0, #7
    vmov.i64 q1, #0
    vmov.i64 d4, #0
    vmov.i64 d5, d0
    vstm r0!, {d0-d5}

    pop {pc}

#elif FB_POLYN == 571
    push {r4, lr}
    bic r4, sp, #15
    vstmdb  r4!, {d8-d15}

    //load t[0]->x
    vldm r1!, {d0-d8}
    //load t[0]->y
    vldm r1!, {d10-d18}
    //move to t[1]
    add r1, #80
    vmov d9, d18

    //ip = 1 (i)
    mov r12, #1
    //r2 = (1 << w)
    lsl r2, r12, r2
back:
    //while (ip < r2)
    cmp r12, r2
    bge end

    //load t[i]->x
    vldm r1!, {d18-d26}

    mov lr, #0xFF
    cmp r3, r12
    moveq lr, #0
    vdup.8 q15, lr

    select9 q15, d30, q0, q1, q2, q3, d8, q9, q10, q11, q12, d26, q0, q1, q2, q3, d8

    //load t[i]->y
    vldm r1!, {d18-d26}

    //move to t[i+1]
    add r1, #80
    add r12, #1

    select9 q15, d30, q5, q6, q7, q8, d9, q9, q10, q11, q12, d26, q5, q6, q7, q8, d9

    b back
end:
    vmov d18,d9
    vstm r0!, {d0-d8}
    vstm r0!, {d10-d18}

    vmov.i64 d0, #0xFF
    vmov.i64 d1, #0
    vshr.U64 d0, #7
    vmov.i64 q1, #0
    vmov.i64 q2, #0
    vmov.i64 q3, #0
    vmov.i64 d8, #0
    vmov.i64 d9, d0
    vstm r0!, {d0-d9}

    vldmia  r4!, {d8-d15}
    pop {r4, pc}
#elif FB_POLYN == 353
    push {lr}

    //load t[0]->x
    vldm r1!, {d16-d21}
    //load t[0]->y
    vldm r1!, {d22-d27}
    //move to t[1]
    add r1, #56

    //ip = 1 (i)
    mov r12, #1
    //r2 = (1 << w)
    lsl r2, r12, r2
back:
    //while (ip < r2)
    cmp r12, r2
    bge end

    //load t[i]->x
    vldm r1!, {d0-d5}

    mov lr, #0xFF
    cmp r3, r12
    moveq lr, #0
    vdup.8 q15, lr

    select6 q15, d30, q8, q9, q10, q0, q1, q2, q8, q9, q10

    //load t[i]->y
    vldm r1!, {d0-d5}

    //move to t[i+1]
    add r1, #56
    add r12, #1

    select6 q15, d30, q11, q12, q13, q0, q1, q2, q11, q12, q13

    b back
end:
    vstm r0!, {d16-d21}
    vstm r0!, {d22-d27}

    vmov.i64 d0, #0xFF
    vmov.i64 d1, #0
    vshr.U64 d0, #7
    vmov.i64 q1, #0
    vmov.i64 q2, #0
    vmov.i64 d6, d0
    vstm r0!, {d0-d6}

    pop {pc}

#else
#error "Field not supported"
#endif

bn_ccopyn_low:
#if FB_POLYN == 163
    vldm r0, {d0-d2}
    vldm r1, {d16-d18}
    rsb r2, #0
    vdup.32 q15, r2

    select3 q15, d30, q8, d18, q0, d2, q8, d18

    vstm r0, {d16-d18}
    bx lr
#elif FB_POLYN == 251
    vldm r0, {d0-d3}
    vldm r1, {d16-d19}
    rsb r2, #0
    vdup.32 q15, r2

    select4 q15, q8, q9, q0, q1, q8, q9

    vstm r0, {d16-d19}
    bx lr
#elif FB_POLYN == 283
    vldm r0, {d0-d4}
    vldm r1, {d16-d20}
    rsb r2, #0
    vdup.32 q15, r2

    select5 q15, d30, q8, q9, d20, q0, q1, d4, q8, q9, d20

    vstm r0, {d16-d20}
    bx lr
#elif FB_POLYN == 353
    vldm r0, {d0-d5}
    vldm r1, {d16-d21}
    rsb r2, #0
    vdup.32 q15, r2

    select6 q15, d30, q8, q9, q10, q0, q1, q2, q8, q9, q10

    vstm r0, {d16-d21}
    bx lr
#elif FB_POLYN == 571
    vldm r0, {d0-d8}
    vldm r1, {d16-d24}
    rsb r2, #0
    vdup.32 q15, r2

    select9 q15, d30, q8, q9, q10, q11, d24, q0, q1, q2, q3, d8, q8, q9, q10, q11, d24

    vstm r0, {d16-d24}
    bx lr
#endif
